
int
copy_fragment(
    HANDLE in_h,
    HANDLE out_h,
    HANDLE log_h,
    char* buff,
    ULONG xbs,
    ULONG* _r,
    __int64 f_ptr
    )
{
        int ok;
        ULONG r;
        ULONG read_bytes;

        fill_buffer(buff, xbs, fill_stringW, fill_stringA);
        ok = FALSE;
        for(r=0; r<retry; r++) {
            set_file_pointer(in_h, f_ptr);
            set_file_pointer(out_h, f_ptr);
            read_bytes = 0;
            if(!ReadFile(in_h, buff, xbs, &read_bytes, NULL) ||
                read_bytes != xbs) {
                read_bytes = GetLastError();
                if(!r) {
                    printf("Can't read block (%d bytes) at offset %I64d (LBA %I64d) error %d\n", xbs, f_ptr, f_ptr/bs, read_bytes);
                }
                Sleep(1000);
                if(new_target && (fill_stringA || fill_stringW)) {
                    goto set_filler;
                }
            } else {
                if(r) {
                    printf("Read on attempt #%d\n", r+1);
                }
set_filler:

                WriteFile(out_h, buff, xbs, &read_bytes, NULL);
                if(read_bytes != xbs) {
                    printf("Can't write block at offset %I64d (LBA %I64d)\n", f_ptr, f_ptr/bs);
                } else {
                    ok = TRUE;
                }
                break;
            }
        }
        if(!ok) {
            bads += xbs;
            if(log_h) {
                sprintf(LogBuffer, "bad at %I64d (LBA %I64d) size %d (%d blocks)\n", f_ptr, f_ptr/bs, xbs, xbs/bs);
                WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
            }
        } else
        if(r) {
            susp += xbs;
            if(log_h) {
                sprintf(LogBuffer, "unreliable at %I64d (LBA %I64d) size %d (%d blocks)\n", f_ptr, f_ptr/bs, xbs, xbs/bs);
                WriteFile(log_h, LogBuffer, strlen(LogBuffer), &read_bytes, NULL);
            }
        }
        //f_ptr += xbs;
        //*copy_count += xbs;

    *_r = r;
    return ok;
}